# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S). Our API is RESTful. It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. You can use your favorite HTTP/REST library for your programming language to use PeerTube. No official SDK is currently provided, but the spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class User(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'float',
        'username': 'str',
        'email': 'str',
        'display_nsfw': 'bool',
        'auto_play_video': 'bool',
        'role': 'int',
        'role_label': 'str',
        'video_quota': 'float',
        'video_quota_daily': 'float',
        'created_at': 'str',
        'account': 'Account',
        'video_channels': 'list[VideoChannel]'
    }

    attribute_map = {
        'id': 'id',
        'username': 'username',
        'email': 'email',
        'display_nsfw': 'displayNSFW',
        'auto_play_video': 'autoPlayVideo',
        'role': 'role',
        'role_label': 'roleLabel',
        'video_quota': 'videoQuota',
        'video_quota_daily': 'videoQuotaDaily',
        'created_at': 'createdAt',
        'account': 'account',
        'video_channels': 'videoChannels'
    }

    def __init__(self, id=None, username=None, email=None, display_nsfw=None, auto_play_video=None, role=None, role_label=None, video_quota=None, video_quota_daily=None, created_at=None, account=None, video_channels=None, local_vars_configuration=None):  # noqa: E501
        """User - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._username = None
        self._email = None
        self._display_nsfw = None
        self._auto_play_video = None
        self._role = None
        self._role_label = None
        self._video_quota = None
        self._video_quota_daily = None
        self._created_at = None
        self._account = None
        self._video_channels = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if username is not None:
            self.username = username
        if email is not None:
            self.email = email
        if display_nsfw is not None:
            self.display_nsfw = display_nsfw
        if auto_play_video is not None:
            self.auto_play_video = auto_play_video
        if role is not None:
            self.role = role
        if role_label is not None:
            self.role_label = role_label
        if video_quota is not None:
            self.video_quota = video_quota
        if video_quota_daily is not None:
            self.video_quota_daily = video_quota_daily
        if created_at is not None:
            self.created_at = created_at
        if account is not None:
            self.account = account
        if video_channels is not None:
            self.video_channels = video_channels

    @property
    def id(self):
        """Gets the id of this User.  # noqa: E501


        :return: The id of this User.  # noqa: E501
        :rtype: float
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this User.


        :param id: The id of this User.  # noqa: E501
        :type: float
        """

        self._id = id

    @property
    def username(self):
        """Gets the username of this User.  # noqa: E501


        :return: The username of this User.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this User.


        :param username: The username of this User.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def email(self):
        """Gets the email of this User.  # noqa: E501


        :return: The email of this User.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this User.


        :param email: The email of this User.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def display_nsfw(self):
        """Gets the display_nsfw of this User.  # noqa: E501


        :return: The display_nsfw of this User.  # noqa: E501
        :rtype: bool
        """
        return self._display_nsfw

    @display_nsfw.setter
    def display_nsfw(self, display_nsfw):
        """Sets the display_nsfw of this User.


        :param display_nsfw: The display_nsfw of this User.  # noqa: E501
        :type: bool
        """

        self._display_nsfw = display_nsfw

    @property
    def auto_play_video(self):
        """Gets the auto_play_video of this User.  # noqa: E501


        :return: The auto_play_video of this User.  # noqa: E501
        :rtype: bool
        """
        return self._auto_play_video

    @auto_play_video.setter
    def auto_play_video(self, auto_play_video):
        """Sets the auto_play_video of this User.


        :param auto_play_video: The auto_play_video of this User.  # noqa: E501
        :type: bool
        """

        self._auto_play_video = auto_play_video

    @property
    def role(self):
        """Gets the role of this User.  # noqa: E501

        The user role (Admin = 0, Moderator = 1, User = 2)  # noqa: E501

        :return: The role of this User.  # noqa: E501
        :rtype: int
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this User.

        The user role (Admin = 0, Moderator = 1, User = 2)  # noqa: E501

        :param role: The role of this User.  # noqa: E501
        :type: int
        """
        allowed_values = [0, 1, 2]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and role not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"  # noqa: E501
                .format(role, allowed_values)
            )

        self._role = role

    @property
    def role_label(self):
        """Gets the role_label of this User.  # noqa: E501


        :return: The role_label of this User.  # noqa: E501
        :rtype: str
        """
        return self._role_label

    @role_label.setter
    def role_label(self, role_label):
        """Sets the role_label of this User.


        :param role_label: The role_label of this User.  # noqa: E501
        :type: str
        """
        allowed_values = ["User", "Moderator", "Administrator"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and role_label not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `role_label` ({0}), must be one of {1}"  # noqa: E501
                .format(role_label, allowed_values)
            )

        self._role_label = role_label

    @property
    def video_quota(self):
        """Gets the video_quota of this User.  # noqa: E501


        :return: The video_quota of this User.  # noqa: E501
        :rtype: float
        """
        return self._video_quota

    @video_quota.setter
    def video_quota(self, video_quota):
        """Sets the video_quota of this User.


        :param video_quota: The video_quota of this User.  # noqa: E501
        :type: float
        """

        self._video_quota = video_quota

    @property
    def video_quota_daily(self):
        """Gets the video_quota_daily of this User.  # noqa: E501


        :return: The video_quota_daily of this User.  # noqa: E501
        :rtype: float
        """
        return self._video_quota_daily

    @video_quota_daily.setter
    def video_quota_daily(self, video_quota_daily):
        """Sets the video_quota_daily of this User.


        :param video_quota_daily: The video_quota_daily of this User.  # noqa: E501
        :type: float
        """

        self._video_quota_daily = video_quota_daily

    @property
    def created_at(self):
        """Gets the created_at of this User.  # noqa: E501


        :return: The created_at of this User.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this User.


        :param created_at: The created_at of this User.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def account(self):
        """Gets the account of this User.  # noqa: E501


        :return: The account of this User.  # noqa: E501
        :rtype: Account
        """
        return self._account

    @account.setter
    def account(self, account):
        """Sets the account of this User.


        :param account: The account of this User.  # noqa: E501
        :type: Account
        """

        self._account = account

    @property
    def video_channels(self):
        """Gets the video_channels of this User.  # noqa: E501


        :return: The video_channels of this User.  # noqa: E501
        :rtype: list[VideoChannel]
        """
        return self._video_channels

    @video_channels.setter
    def video_channels(self, video_channels):
        """Sets the video_channels of this User.


        :param video_channels: The video_channels of this User.  # noqa: E501
        :type: list[VideoChannel]
        """

        self._video_channels = video_channels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, User):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, User):
            return True

        return self.to_dict() != other.to_dict()
